﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Newtonsoft.Json;
using Syncfusion.EJ2.Base;

namespace Razorpages.Pages
{
    public class IndexModel : PageModel
    {
        public static List<Orders> order = new List<Orders>();
        public static List<Employee1Details> employee = new List<Employee1Details>();
        public System.Collections.Generic.List<DropDownData> DropDatasource { get; set; }
        public static List<DropDownData> dropdown = new List<DropDownData>();
        public void OnGet()
        {
            DropDatasource = DropDownData.GetDropData().ToList();
            if (order.Count == 0)
                BindDataSource();
            if (employee.Count == 0)
                BindDataSourceE();
        }

        public void BindDataSource()
        {
            order.Add(new Orders(10248, 1, new string[] { "VINET" }, "Reims"));
            order.Add(new Orders(10249, 2, new string[] { "ALFKI" }, "Münster"));
            order.Add(new Orders(10250, 3, new string[] { "TOMSP" }, "Rio"));
            order.Add(new Orders(10251, 4, new string[] { "HANAR" }, "Lyon"));
            order.Add(new Orders(10252, 5, new string[] { "HILAA" }, "Resende"));
            order.Add(new Orders(10253, 2, new string[] { "CENTC" }, "Graz"));
            order.Add(new Orders(10254, 3, new string[] { "RICSU" }, "México"));
            order.Add(new Orders(10255, 5, new string[] { "ERNSH" }, "Oulu"));
            order.Add(new Orders(10256, 6, new string[] { "RATTC" }, "Lander"));
            order.Add(new Orders(10257, 1, new string[] { "BLONP" }, "Bergamo"));
            order.Add(new Orders(10258, 7, new string[] { "QUICK" }, "Madrid"));
            order.Add(new Orders(10259, 3, new string[] { "LEHMS" }, "Frankfurt"));
            order.Add(new Orders(10260, 1, new string[] { "ROMEY" }, "Reggio"));
            order.Add(new Orders(10261, 2, new string[] { "REGGC" }, "Albuquerque"));
            order.Add(new Orders(10262, 5, new string[] { "BSBEV" }, "Strasbourg"));
        }

        public void BindDataSourceE()
        {
            employee.Add(new Employee1Details(0, "Nancy", "Davolio", 1 + 0));
            employee.Add(new Employee1Details(1, "Andrew", "Fuller", 2 + 3));
            employee.Add(new Employee1Details(2, "Janet", "Leverling", 2 + 2));
            employee.Add(new Employee1Details(3, "Margaret", "Peacock", 1 + 1));
            employee.Add(new Employee1Details(0, "Jadav", "Davolio", 6 + 0));
            employee.Add(new Employee1Details(1, "Dhoni", "Fuller",7 + 3));
            employee.Add(new Employee1Details(2, "Butler", "Leverling", 8 + 2));
            employee.Add(new Employee1Details(3, "Smith", "Peacock", 4 + 1));
        }

        public class DropDownData
        {
            public static List<DropDownData> dropdata = new List<DropDownData>();
            public int CustomerID { get; set; }
            public string OptionText { get; set; }
            public DropDownData()
            {

            }
            public DropDownData(int id, string name)
            {
                this.CustomerID = id;
                this.OptionText = name;
            }

            public static List<DropDownData> GetDropData()
            {
                if (dropdata.Count() == 0)
                {
                dropdata.Add(new DropDownData(1, "Reims"));
                dropdata.Add(new DropDownData(2, "Münster"));
                dropdata.Add(new DropDownData(3, "Rio"));
                dropdata.Add(new DropDownData(4, "Lyon"));
                dropdata.Add(new DropDownData(5, "Resende"));
                dropdata.Add(new DropDownData(6, "Graz"));
                dropdata.Add(new DropDownData(7, "México"));
                dropdata.Add(new DropDownData(8, "Oulu"));
                }
                return dropdata;

            }
        }
        public class Data
        {

            public bool requiresCounts { get; set; }
            public int skip { get; set; }

            public int EmployeeID { get; set; }
            public int EmployeeName { get; set; }
            public int take { get; set; }
        }

        public class AutoCompleteDM
        {
            public bool requiresCounts { get; set; }

            public int take { get; set; }
            public List<Wheres> where { get; set; }

        }

        public class Wheres
        {
            public string field { get; set; }
            public bool ignoreAccent { get; set; }

            public bool ignoreCase { get; set; }

            public bool isComplex { get; set; }

            public string value { get; set; }
            public string Operator { get; set; }

        }
 


        public JsonResult OnPostAutoCompleteDataSource([FromBody]AutoCompleteDM dm)
        {
            var data = employee;
            int count = data.Cast<Employee1Details>().Count();            
            if (dm.where != null)
            {
                data = (from cust in data
                        where cust.FirstName.ToLower().StartsWith(dm.@where[0].value.ToString())
                        select cust).ToList();
            }
            if (dm.take != 0)
            {
                data = data.Take(dm.take).ToList();
            }           
            return dm.requiresCounts ? new JsonResult(new { result = data, count = count }) : new JsonResult(data);
        }

        public JsonResult OnPostDataSource([FromBody]Data dm)
        {
            //var data = Orders.GetAllRecords();
            var data = order;

            int count = data.Cast<Orders>().Count();
            return dm.requiresCounts ? new JsonResult(new { result = data.Skip(dm.skip).Take(dm.take), count = count }) : new JsonResult(data);


        }

        public JsonResult OnPostChildDataSource([FromBody]DataManagerRequest dm)
        {
                IEnumerable data = Employee1Details.GetAllRecords();

                DataOperations operation = new DataOperations();

                int count = data.Cast<Employee1Details>().Count();

                if (dm.Where != null && dm.Where.Count > 0) //Filtering
                {
                    data = operation.PerformFiltering(data, dm.Where, dm.Where[0].Operator);
                }
                return dm.RequiresCounts ? new JsonResult(new { result = data, count = count }) : new JsonResult(data);
        }

        public JsonResult OnPostInsert([FromBody]CRUDModel<Orders> value)
        {

            Orders.GetAllRecords().Insert(0, value.Value);
            return new JsonResult(value.Value);
        }

        public JsonResult OnPostUpdate([FromBody]CRUDModel<Orders> value)
        {
            var ord = value.Value;
            Orders val = Orders.GetAllRecords().Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
            val.OrderID = ord.OrderID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.ShipCity = ord.ShipCity;

            return new JsonResult(value.Value);
        }


        public JsonResult OnPostDelete([FromBody]CRUDModel<Orders> value)
        {
            Orders.GetAllRecords().Remove(Orders.GetAllRecords().Where(or => or.OrderID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return new JsonResult(value);
        }



        public JsonResult OnPostBatchUpdate([FromBody]CRUDModel batchmodel)
        {
            if (batchmodel.Changed.Count != 0)
            {
                for (var i = 0; i < batchmodel.Changed.Count(); i++)
                {
                    var ord = batchmodel.Changed[i];
                    Orders val = order.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
                    val.OrderID = ord.OrderID;
                    val.EmployeeID = ord.EmployeeID;
                    val.CustomerID = ord.CustomerID;
                    val.ShipCity = ord.ShipCity;
                }
            }

            if (batchmodel.Deleted.Count != 0)
            {
                for (var i = 0; i < batchmodel.Deleted.Count(); i++)
                {
                    order.Remove(order.Where(or => or.OrderID == batchmodel.Deleted[i].OrderID).FirstOrDefault());
                }
            }

            if (batchmodel.Added.Count != 0)
            {
                for (var i = 0; i < batchmodel.Added.Count(); i++)
                {
                    order.Insert(0, batchmodel.Added[i]);
                }
            }
            var data = order.ToList();
            return new JsonResult(data);
        }

        public JsonResult OnPostChildBatchUpdate([FromBody]CRUDModel1 batchmodelc)
        {
                if (batchmodelc.Changed.Count != 0)
                {
                    for (var i = 0; i < batchmodelc.Changed.Count(); i++)
                    {
                        var orde = batchmodelc.Changed[i];
                        Employee1Details val = employee.Where(or => or.EmployeeID == orde.EmployeeID).FirstOrDefault();
                        val.EmployeeID = orde.EmployeeID;
                        val.FirstName = orde.FirstName;
                        val.LastName = orde.LastName;
                        val.ReportsTo = orde.ReportsTo;
                    }
                }

                if (batchmodelc.Deleted.Count != 0)
                {
                    for (var i = 0; i < batchmodelc.Deleted.Count(); i++)
                    {
                        employee.Remove(employee.Where(or => or.EmployeeID == batchmodelc.Deleted[i].EmployeeID).FirstOrDefault());
                    }
                }

                if (batchmodelc.Added.Count != 0)
                {
                    for (var i = 0; i < batchmodelc.Added.Count(); i++)
                    {
                        employee.Insert(0, batchmodelc.Added[i]);
                    }
                }
                var data = employee.ToList();
                return new JsonResult(data);
        }

        public class DataC
        {

            public bool requiresCounts { get; set; }
            public int skip { get; set; }

            public int EmployeeID { get; set; }
            public int FirstName { get; set; }
            public int take { get; set; }
        }

        public JsonResult OnPostUrlDatasource([FromBody]DataManagerRequest dm)
        {
            var val = employee;
            var Data = val.ToList();
            var count = val.Count();
            if (dm.Where != null)
            {
                Data = (from cust in Data
                        where cust.FirstName.ToLower().StartsWith(dm.Where[0].value.ToString())
                        select cust).ToList();
            }
            if (dm.Take != 0)
                Data = Data.Take(dm.Take).ToList();
            return new JsonResult(Data);
        }

        public class CRUDModel
        {
            public List<Orders> Added { get; set; }
            public List<Orders> Changed { get; set; }
            public List<Orders> Deleted { get; set; }
            public Orders Value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
        }
        public class CRUDModel1
        {
            public List<Employee1Details> Added { get; set; }
            public List<Employee1Details> Changed { get; set; }
            public List<Employee1Details> Deleted { get; set; }
            public Employee1Details Value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
        }



        public class Orders
        {
            public static List<Orders> order = new List<Orders>();
            public Orders()
            {

            }
            public Orders(int OrderID, int EmployeeID, string[] CustomerID, string ShipCity)
            {
                this.OrderID = OrderID;
                this.EmployeeID = EmployeeID;
                this.CustomerID = CustomerID;
                this.ShipCity = ShipCity;
            }
            public static List<Orders> GetAllRecords()
            {
                if (order.Count() == 0)
                {
                    order.Add(new Orders(10248, 1, new string[] { "VINET" }, "Reims"));
                    order.Add(new Orders(10249, 2, new string[] { "ALFKI" }, "Münster"));
                    order.Add(new Orders(10250, 3, new string[] { "TOMSP" }, "Rio"));
                    order.Add(new Orders(10251, 4, new string[] { "HANAR" }, "Lyon"));
                    order.Add(new Orders(10252, 5, new string[] { "HILAA" }, "Resende"));
                    order.Add(new Orders(10253, 2, new string[] { "CENTC" }, "Graz"));
                    order.Add(new Orders(10254, 3, new string[] { "RICSU" }, "México"));
                    order.Add(new Orders(10255, 5, new string[] { "ERNSH" }, "Oulu"));
                    order.Add(new Orders(10256, 6, new string[] { "RATTC" }, "Lander"));
                    order.Add(new Orders(10257, 1, new string[] { "BLONP" }, "Bergamo"));
                    order.Add(new Orders(10258, 7, new string[] { "QUICK" }, "Madrid"));
                    order.Add(new Orders(10259, 3, new string[] { "LEHMS" }, "Frankfurt"));
                    order.Add(new Orders(10260, 1, new string[] { "ROMEY" }, "Reggio"));
                    order.Add(new Orders(10261, 2, new string[] { "REGGC" }, "Albuquerque"));
                    order.Add(new Orders(10262, 5, new string[] { "BSBEV" }, "Strasbourg"));
                }
                //if (order.Count() == 0)
                //{
                //    int code = 10000;
                //    for (var i = 1; i < 10000; i++)
                //    {
                //        order.Add(new OrdersDetails(code + i, "ALFKI", i + 1, 2.3 * i, false, new DateTime(1991, 05, 15), "Berlin" + i, "Simons bistro" + i, "Denmark" + i, new DateTime(1996, 7, 16), "Kirchgasse 6" + i));
                //    }
                //}
                return order;
            }
            public int OrderID { get; set; }
            public int EmployeeID { get; set; }
            public string[] CustomerID { get; set; }
            public string ShipCity { get; set; }
        }

        public class Employee1Details
        {
            public Employee1Details()
            {

            }
            public Employee1Details(int EmployeeId, string FirstName, string LastName, int ReportsTO)
            {
                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
                this.LastName = LastName;
                this.ReportsTo = ReportsTo;
            }
            public static List<Employee1Details> GetAllRecords()
            {
                if (employee.Count() == 0)
                {
                    for (int i = 1; i < 2; i++)
                    {
                        employee.Add(new Employee1Details(i + 0, "Nancy", "Davolio", i + 0));
                        employee.Add(new Employee1Details(i + 1, "Andrew", "Fuller", i + 3));
                        employee.Add(new Employee1Details(i + 2, "Janet", "Leverling", i + 2));
                        employee.Add(new Employee1Details(i + 3, "Margaret", "Peacock", i + 1));
                        employee.Add(new Employee1Details(i + 0, "Jadav", "Davolio", i + 0));
                        employee.Add(new Employee1Details(i + 1, "Dhoni", "Fuller", i + 3));
                        employee.Add(new Employee1Details(i + 2, "Butler", "Leverling", i + 2));
                        employee.Add(new Employee1Details(i + 3, "Smith", "Peacock", i + 1));

                    }
                }
                return employee;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public int ReportsTo { get; set; }
        }
    }
}

